/*
 * Copyright (C) 2000-2002 by Pedestal Software, Inc.
 * All Rights Reserved. Use at your own risk!
 * Email: support@pedestalsoftware.com
 *
 * This code is provided as Open Source with restrictions. See the readme
 * file that came with the distribution for details.
 *
 */

/* dutil.c */

#include "driver.h"

#ifdef DEBUG

void dumpbuf(void *p, int size) {
  int l,i;
  WCHAR buf[500];
  char c[5];
  for (l=0; l<size; l+=5) {
    for (i=0; i<5; i++) {
      c[i] = (*(((unsigned char *)p)+l+i));
      if (!isprint(c[i])) c[i]='.';
    }

    swprintf(buf,
	     L"%d 0x%0.2x 0x%0.2x 0x%0.2x 0x%0.2x 0x%0.2x %C%C%C%C%C\n",
	     l,
	     (*(((unsigned char *)p)+l)),
	     (*(((unsigned char *)p)+l+1)),
	     (*(((unsigned char *)p)+l+2)),
	     (*(((unsigned char *)p)+l+3)),
	     (*(((unsigned char *)p)+l+4)),
	     c[0], c[1], c[2], c[3], c[4]
	     );
    debugOutput(buf);
  }
}


void say_process_mask(ACCESS_MASK mask) {
  if ((mask & PROCESS_ALL_ACCESS) == PROCESS_ALL_ACCESS)
    debugOutput(L"   PROCESS_ALL_ACCESS\n");
  else {
    if (mask & PROCESS_TERMINATE) debugOutput(L"   TERMINATE\n");
    if (mask & PROCESS_CREATE_THREAD) debugOutput(L"   CREATE_THREAD\n");
    if (mask & PROCESS_SET_SESSIONID) debugOutput(L"   SET_SESSION_ID\n");
    if (mask & PROCESS_VM_OPERATION) debugOutput(L"   VM_OPERATION\n");
    if (mask & PROCESS_VM_READ) debugOutput(L"   VM_READ\n");
    if (mask & PROCESS_VM_WRITE) debugOutput(L"   VM_WRITE\n");
    if (mask & PROCESS_DUP_HANDLE) debugOutput(L"   DUP_HANDLE\n");
    if (mask & PROCESS_CREATE_PROCESS) debugOutput(L"   CREATE_PROCESS\n");
    if (mask & PROCESS_SET_QUOTA) debugOutput(L"   SET_QUOTA\n");
    if (mask & PROCESS_SET_INFORMATION) debugOutput(L"   SET_INFORMATION\n");
    if (mask & PROCESS_QUERY_INFORMATION)
      debugOutput(L"   QUERY_INFORMATION\n");
    if ((mask & STANDARD_RIGHTS_REQUIRED)==STANDARD_RIGHTS_REQUIRED)
      debugOutput(L"   STANDARD_RIGHTS_REQUIRED\n");
    else {
      if (mask & SYNCHRONIZE) debugOutput(L"   SYNCHRONIZE\n");
    }
  }
}


#endif
